#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   server_createTempCase.py
#
#       指定したcaseをコピーしてtempケースを指定した場所に作成する。
#       tempケースは、ascii形式でデータ部を簡略化した状態で作成。
#
#   17/04/17    新規作成
#

import os
import sys
import glob
import server_getFoamContents

#
#  getCaseDir
#    fieldDirからcaseDirを取得する
def getCaseDir(fieldDir):
    folder = fieldDir.split("/")[-1]
    try:
        a=float(folder)
        currTime = folder
        caseDir = "/".join(fieldDir.split("/")[:-1])
        region = "."
    except:
        currTime = fieldDir.split("/")[-2]
        caseDir = "/".join(fieldDir.split("/")[:-2])
        region = folder
    return caseDir

#
#  getSaveFolder
#    gridEditorのtitleからsaveFolder名を取得
def getSaveFolder(title):
    i = 0
    ns = -1
    for chara in title:
        if chara == "(":
            ns = i
        i += 1
    i = ns
    ne = -1
    for chara in title[ns:]:
        if chara == ")":
            ne = i
        i += 1
    gridNo = title[ns:ne].split(":")[-1]
    folderName = "gridTemp_" + gridNo
    return folderName

#
#  creaeTempFolder
#    tempFolderを作成する
def createTempFolder(tempDir, caseDir):
    if len(glob.glob(tempDir)) != 0:
        comm = "rm -rf " + tempDir + "/*"
        os.system(comm)
    else:
        comm = "mkdir " + tempDir
        os.system(comm)
    fileName = tempDir + "/caseDir"
    f = open(fileName, "w")
    f.write(caseDir)
    f.close()
    fileName = tempDir + "/boundaryDir"
    f = open(fileName, "w")
    f.write(boundaryDir)
    f.close()
    fileName = tempDir + "/fieldDir"
    f = open(fileName, "w")
    f.write(fieldDir)
    f.close()
    return

#
#  createGridTemp
#    boundaryとfield内容を取得する
def createGridTemp(tempDir, caseDir, boundaryDir, fieldDir):
    #caseの作成
    caseName = caseDir.split("/")[-1]
    newDir = tempDir + "/" + caseName
    comm = "mkdir " + newDir
    os.system(comm)
    #boundary保存用のfolderを作成
    relativeDir = boundaryDir[len(caseDir)+1:]
    words = relativeDir.split("/")
    newDir = tempDir + "/" + caseName
    for word in words:
        newDir += "/" + word
        if len(glob.glob(newDir)) == 0:
            comm = "mkdir " + newDir
            os.system(comm)
    #boundaryの読み込み
    fileName = boundaryDir + "/boundary"
    comm = "cp " + fileName + " " + newDir
    os.system(comm)
    #timeFolderを作成
    relativeDir = fieldDir[len(caseDir)+1:]
    words = relativeDir.split("/")
    newDir = tempDir + "/" + caseName
    for word in words:
        newDir += "/" + word
        if len(glob.glob(newDir)) == 0:
            comm = "mkdir " + newDir
            os.system(comm)
    #field読み込み、書き込み
    files = glob.glob(fieldDir + "/*")
    for fileName in files:
        if os.path.isfile(fileName) == True:
            comm = "cp " + fileName + " " + newDir
            os.system(comm)


#メイン
if __name__ == "__main__":
    #title = sys.argv[1]
    boundaryDir = sys.argv[1]
    fieldDir = sys.argv[2]
    saveDir = sys.argv[3]
    #dirを整形
    boundaryDir = os.path.expanduser(boundaryDir)
    boundaryDir = os.path.abspath(boundaryDir)
    fieldDir = os.path.expanduser(fieldDir)
    fieldDir = os.path.abspath(fieldDir)
    saveDir = os.path.expanduser(saveDir)
    saveDir = os.path.abspath(saveDir)
    #caseDirを取得
    caseDir = getCaseDir(fieldDir)
    #tempDirを取得
    #saveFolder = getSaveFolder(title)
    #tempDir = saveDir + "/" + saveFolder
    tempDir = saveDir
    createTempFolder(tempDir, caseDir)
    #boundary,fieldsをコピー
    createGridTemp(tempDir, caseDir, boundaryDir, fieldDir)



