#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   copyToSystemClipBoar.py
#
#       systemClipBoardにコピーする
#
#   15/06/24    新規作成
#   18/01/18    nautilusのバージョンからdesktop名を取得し、desktopに応じたcopiedFilesを作成
#               desktop名が異なってもコピーできる様に修正
#      06/11    「gtk.clipboard_get()」→「gtk.Clipboard()」に変更
#               copy後の「gtk.main_quit()」を削除
#

import sys
import os
import pygtk
pygtk.require('2.0')
import gtk
import urllib
import pyTreeFoam

import logFileCreater; logFileCreater.log()


#sysClipboard = gtk.clipboard_get()
sysClipboard = gtk.Clipboard()


#
#  copyToSystemClipBoard
#    clipboardにコピーする
def copyToSystemClipBoard(fileName):
    f=open(fileName); lines=f.readlines(); f.close()
    folders = "".join(lines[1:]).split()
    sysCopyFolders(folders)

def sysCopyFolders(folders):
    action = "copy"

    def get_func(sysClipboard, selectiondata, info, data):
        txt = action + "\n" + "\n".join(paths_to_uris(folders))
        selectiondata.set(selectiondata.get_target(), 8, txt)
        #gtk.main_quit()

    def clear_func(sysClipboard,data):
        print "clear_func"

    #nautilusのバージョンを確認
    comm = "nautilus --version"
    [stat, result] = pyTreeFoam.runShellCommandReturnCont(comm)
    if stat == "OK":
        dsktop = result.split()[0].lower()
        #copiedFilesを作成
        copiedFiles = "x-special/" + dsktop + "-copied-files"
        targets = [ (copiedFiles, 0, 0), ("text/uri-list", 0, 0) ]
        #targets = [ ('x-special/gnome-copied-files', 0, 0), ("text/uri-list", 0, 0) ]
        ret = sysClipboard.set_with_data(targets, get_func, clear_func)

#
#  paths_to_uris
#    path名をURIに変換
def paths_to_uris(paths):
    uris = []
    for path in paths:
        uri = u"file://" + urllib.quote(path)
        uris.append(uri)
    return uris


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    fileName = sys.argv[1]
    copyToSystemClipBoard(fileName)

    #gtkから抜け出ない
    gtk.main()

